"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiffParser = void 0;
const fs_extra_1 = __importDefault(require("fs-extra"));
const path_1 = __importDefault(require("path"));
const child_process_1 = __importDefault(require("child_process"));
const gitdiffParser = require("gitdiff-parser");
class DiffParser {
    constructor(hash, opt = {}) {
        this.stdout = '';
        this.hash = hash;
        if (typeof hash !== 'string') {
            this.hash = '';
        }
        this.opt = opt;
    }
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.exec();
            return this.parserDiff();
        });
    }
    exec() {
        return __awaiter(this, void 0, void 0, function* () {
            const rootPath = path_1.default.resolve(this.opt.cwd || process.cwd(), '.git');
            if (!fs_extra_1.default.existsSync(rootPath)) {
                throw new Error('请选择 git 仓库运行');
            }
            this.stdout = yield new Promise((resolve, reject) => {
                child_process_1.default.exec(`git diff ${this.hash}`, this.opt, (err, stdout) => {
                    if (err) {
                        reject(err);
                    }
                    resolve(stdout);
                });
            });
        });
    }
    parserDiff() {
        return gitdiffParser.parse(this.stdout);
    }
}
exports.DiffParser = DiffParser;
