"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileStream = void 0;
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const index_1 = require("./index");
class FileStream extends index_1.Stream {
    constructor(content, filePath, opts) {
        super(content);
        this.opts = {};
        if (typeof filePath === 'string') {
            this.opts.filePath = filePath;
            this.opts.type = (opts === null || opts === void 0 ? void 0 : opts.type) || 'json';
            return;
        }
        if (filePath instanceof Object) {
            this.opts.filePath = filePath.filePath || process.cwd();
            this.opts.type = filePath.type || 'json';
            return;
        }
        this.opts.filePath = process.cwd();
        this.opts.type = 'json';
    }
    outToStream() {
        let res = '';
        if (this.opts.type === 'yaml') {
            res = super.dumpYaml();
        }
        else {
            res = this.dumpJSON();
        }
        fs_extra_1.default.writeFileSync(path_1.default.resolve(this.opts.filePath, `output.${this.opts.type === 'yaml' ? 'yml' : 'json'}`), res);
    }
}
exports.FileStream = FileStream;
